/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Mouse Gestures for Mozilla.
 *
 * The Initial Developer of the Original Code is Jens Bannmann.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s) (alphabetical order):
 *  Jens Bannmann <jens.b@web.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var isPhoenix; // stores whether window is phoenix browser
var windowType; // type of the window this mozgest instance is working on

windowType = document.location.href;
windowType = windowType.substring(9, windowType.indexOf("/", 9));
if (windowType == "browser") {
  windowType = "navigator";
  isPhoenix = true;
} else {
  isPhoenix = false;
  // quick hack to set messenger pref to true if not present
  mgGetPref("messenger", "Bool", true);
}


var contextMenuID = new Array();
contextMenuID["navigator"] = "contentAreaContextMenu";
contextMenuID["messenger"] = "messagePaneContext";

function mgGetContextMenu() {
  return document.getElementById(contextMenuID[windowType]);
}


var contentAreaID = new Array();
contentAreaID["messenger"] = "messagepane";

function mgGetContentArea() {
  if (windowType == "navigator") {
    return getBrowser();
  } else {
    return document.getElementById(contentAreaID[windowType]);
  }
}


// mozgestIsInContent is called from event listener in capture phase
// when the event has occured in content area
function mozgestIsInContent(e){
  // do not allow gestures on tab toolbar
  if (mgGetContentArea().nodeName == "tabbrowser") {
    var cur = e.originalTarget;
    while (cur != null && cur != mgGetContentArea()) {
      if (cur.nodeName == "HTML") {     //   = event happened in the browser
        inContent = true;
      }
      cur = cur.parentNode;
    }
  } else {
    inContent = true;
  }
}


function mgIsEnabled() {
  return mgGetPref(windowType, "Bool", true);
}